HDU 5073 Galaxy(贪心)

题目链接:HDU 5073 Galaxy

题面:

Galaxy

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)

Total Submission(s): 2571    Accepted Submission(s): 642

Special Judge

Problem Description

Good news for us: to release the financial pressure, the government started selling galaxies and we can buy them from now on! The first one who bought a galaxy was Tianming Yun and he gave it to Xin Cheng as a present.

To be fashionable, DRD also bought himself a galaxy. He named it Rho Galaxy. There are n stars in Rho Galaxy, and they have the same weight, namely one unit weight, and a negligible volume. They initially lie in a line rotating around their center of mass.

Everything runs well except one thing. DRD thinks that the galaxy rotates too slow. As we know, to increase the angular speed with the same angular momentum, we have to decrease the moment of inertia.

The moment of inertia I of a set of n stars can be calculated with the formula

where wi is the weight of star i, di is the distance form star i to the mass of center.

As DRD’s friend, ATM, who bought M78 Galaxy, wants to help him. ATM creates some black holes and white holes so that he can transport stars in a negligible time. After transportation, the n stars will also rotate around their new center of mass. Due to financial
pressure, ATM can only transport at most k stars. Since volumes of the stars are negligible, two or more stars can be transported to the same position.

Now, you are supposed to calculate the minimum moment of inertia after transportation.

Input

The first line contains an integer T (T ≤ 10), denoting the number of the test cases.

For each test case, the first line contains two integers, n(1 ≤ n ≤ 50000) and k(0 ≤ k ≤ n), as mentioned above. The next line contains n integers representing the positions of the stars. The absolute values of positions will be no more than 50000.

Output

For each test case, output one real number in one line representing the minimum moment of inertia. Your answer will be considered correct if and only if its absolute or relative error is less than 1e-9.

Sample Input

2
3 2
-1 0 1
4 2
-2 -1 1 2

Sample Output

0
0.5

Source

2014 Asia AnShan Regional Contest

解题:

重心的位置时所有位置的平均数,而能移动的点最后肯定都落在重心上。故只需找出哪些是保留的点,而保留的点应该是连续的,这样才能保证力矩之和最小。直接暴力是n^2,显然会超时。因为要求的是,∑从1到n(d^2),而(di-dave)^2可以拆分成di^2-2*di*dave+dave^2可以先预处理di和di^2的累积和,最后算的时候直接取就行了。因为初值取太小了,导致wa多次。貌似是需要,排下序的。

总结:

1.不要认为题目给定的都是有序的。

2.求最值,初值应设为第一项或末项的值。

代码:

#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
using namespace std;

int main()
{
    int t,n,k;
    long long int p[50000+10];
    long long int d[50000+10];
    long long int ds[50000+10];
    double center;
    double minn=0,temp;
    cin>>t;
    while(t--)
    {
        minn=9999999999999999;
        cin>>n>>k;
        for(int i=1;i<=n;i++)
            cin>>p[i];
        sort(p+1,p+n+1);
        if(n==k||n-k==1)
        {
            printf("0\n");
            continue;
        }
        d[0]=0;
        ds[0]=0;
        for(int i=1;i<=n;i++)
        {
            d[i]=d[i-1]+p[i];
            ds[i]=ds[i-1]+p[i]*p[i];
        }
        for(int i=0;i<=k;i++)
        {
            center=(d[i+n-k]-d[i])*1.0/(n-k);
            temp=(ds[i+n-k]-ds[i])-2*center*(d[i+n-k]-d[i])+(n-k)*center*center;
            if(temp<minn)
                minn=temp;
        }
        printf("%.9f\n",minn);
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-05 05:41:35

HDU 5073 Galaxy(贪心)的相关文章

HDU 5073 Galaxy(贪心)

题目大意:给你n个点,拿走k个之后,让你求出怎么拿使得剩下的inertia最小. 解体思路:贪心的策略.剩下的数只有当连续的时候,值会最小,枚举一遍求出来间距为n-k的最小的inertia. PS:(x1-d)^2+(x2-d)^2+--+(xn-d)^2 = sum(x1^2+--+xn^2)+n*d*d-2*n(sum(x1+x2+--+xn)). Galaxy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/26

hdu 5073 Galaxy(数学)

题目链接:hdu 5073 Galaxy 题目大意:给定N个点,可以移动其中的K的点,问说最后I的最小值可以是多少. 解题思路:因为质量都为1嘛,所以就是求方差,可以移动K个,所以即选连续的n=N-K个使得方差最小.注意N=K的情 况. S表示n个数的和,T表示n个数平方的和,那么这n个数的方差即为T - S * S / n,然后扫描一遍数组维护S,T,并且计算 方差的最小值. #include <cstdio> #include <cstring> #include <al

HDU 5073 Galaxy (2014鞍山现场赛D题)

题目链接:HDU 5073 Galaxy 题意:在一维的坐标系里,给出N个点坐标,转动K个点,使转动后这个星系的的惯性最小(根据题意惯性最小也就是 求所有星星到星系中心的距离最小,这个可以理解成方差最小).求最小的惯性. 思路: 先对序列排序,再求出算N-K个点惯性的递推式. 以三个为例: 预处理是 平均数和各项的平方和, 注意:n==k的特判 AC代码: #include <stdio.h> #include <algorithm> using namespace std; do

hdu 5073 Galaxy(2014acm亚洲赛区鞍山 D)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5073 Galaxy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 768    Accepted Submission(s): 179 Special Judge Problem Description Good news for u

hdu 5073 Galaxy(2014acm亚洲赛区鞍山 C)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5073 Galaxy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 768    Accepted Submission(s): 179 Special Judge Problem Description Good news for u

HDU 5073 Galaxy(Anshan 2014)(数学推导,贪心)

Galaxy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 556    Accepted Submission(s): 127 Special Judge Problem Description Good news for us: to release the financial pressure, the government

hdu 5073 Galaxy(2014 鞍山现场赛)

Galaxy                                                                   Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 577    Accepted Submission(s): 132 Special Judge Problem Description G

HDU 5073 Galaxy (数学)

Galaxy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)Total Submission(s): 4991    Accepted Submission(s): 1215Special Judge Problem Description Good news for us: to release the financial pressure, the government

HDU 5073 Galaxy(居然是暴力)

Problem Description Good news for us: to release the financial pressure, the government started selling galaxies and we can buy them from now on! The first one who bought a galaxy was Tianming Yun and he gave it to Xin Cheng as a present. To be fashi